<template>
	<v-img v-if="image" :src="image" @load="onImageLoad">
		<div v-for="t in tasks" :key="t.id">
			<!-- Omit router links when disabled -->
			<div v-if="disableLinks">
				<v-icon
					class="absolute icon-border"
					:color="priorityToColor(t.priority)"
					:style="getMarkerPostion(t)"
				>fa-map-marker-alt</v-icon>
			</div>

			<!-- Add router links when enabled -->
			<div v-else>
				<router-link tag="div" :to="routeLink(t.id)">
					<v-icon
						class="absolute icon-border"
						:color="priorityToColor(t.priority)"
						:style="getMarkerPostion(t)"
					>fa-map-marker-alt</v-icon>
				</router-link>
			</div>
		</div>
	</v-img>
</template>

<script>
import { priorities } from "@/models/Task";

export default {
	props: {
		tasks: {
			type: Array,
			required: true,

			validator: function(value) {
				if (value.length < 1) {
					return false;
				}

				let image = value[0].image;
				return value.reduce((total, current) => {
					return current.image === image && total;
				}, true);
			}
		},

		disableLinks: {
			type: Boolean,
			required: false,
			default: false
		}
	},

	computed: {
		image() {
			return this.tasks[0] ? this.tasks[0].image : "";
		}
	},

	methods: {
		priorityToColor(priority) {
			switch (priority) {
				case priorities.LOW:
					return "success";
				case priorities.HIGH:
					return "error";
				default:
					return "info";
			}
		},

		getMarkerPostion(task) {
			return {
				left: task.position.x * 100 + "%",
				top: task.position.y * 100 + "%"
			};
		},

		onImageLoad() {
			this.imageLoaded = true;
		},

		routeLink(id) {
			return { name: "task", params: { id: id } };
		}
	}
};
</script>

<style lang="scss" scoped>
.relative {
	position: relative;
}

.absolute {
	position: absolute;
}

.icon-border {
	text-shadow: 0 0 2px black;
}
</style>
